<template>
  <div class="pagination row mb-3">
    <div class="col-md-6 text-center text-md-left">
      <div class="d-inline-block">
        <ul class="pagination flex-wrap">
          <li :class="['page-item', { disabled: current === 1 }]">
            <router-link class="page-link" :to="routeTo(previous)">Prev</router-link>
          </li>
          <li v-for="(n, key) in pages" :key="key" :class="['page-item', { active: current === n, disabled: n === 0 }]">
            <router-link class="page-link" v-if="n != 0" :to="routeTo(n)">{{ n }}</router-link>
            <a class="page-link" v-else>...</a>
          </li>
          <li :class="['page-item', { disabled: current === pageCount }]">
            <router-link class="page-link" :to="routeTo(next)">Next</router-link>
          </li>
        </ul>
      </div>
    </div>
    <div class="col-md-6 text-center text-md-right">
      <div class="d-inline-block">
        <div class="input-group mb-3">
          <div class="input-group-prepend">
            <label class="input-group-text" for="paginationlimit">{{ totalText }}</label>
          </div>
          <select class="custom-select" id="paginationlimit" v-model="selectedLimit" @change="onLimitChange">
            <option v-for="number in limitOptions" :key="number" :value="number">{{ number }} per page</option>
          </select>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
const MAX_PAGES_PER_BLOCK = 3

import { ref, computed } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import Constants from '../constants.js'
import StringHelper from '../lib/string-helper.js'

export default {
  name: 'PaginationNav',
  props: {
    total: { type: Number, required: true },
    offset: { type: Number, default: 0 },
    defaultOffset: { type: Number, default: 0 },
    limit: { type: Number, default: Constants.pagination.defaultPageLimit },
    omit: { type: Array, default: () => [] }, // don't use the following query params in the pagination routes
    singular: { type: String, default: 'page' },
    plural: { type: String, default: 'pages' },
  },
  setup(props) {
    const router = useRouter()
    const route = useRoute()

    const selectedLimit = ref(props.limit)
    const limitOptions = ref([5, 10, 20, 50, 100])

    const pageCount = computed(() => {
      return Math.ceil(props.total / parseInt(selectedLimit.value))
    })

    const current = computed(() => {
      return Math.floor(props.offset / parseInt(selectedLimit.value)) + 1
    })

    const previous = computed(() => {
      return current.value - 1
    })

    const next = computed(() => {
      return current.value + 1
    })

    const totalText = computed(() => {
      return StringHelper.noun(
        props.total,
        props.singular ? props.singular : 'item',
        props.plural ? props.plural : 'items'
      )
    })

    const pages = computed(() => {
      // Within block plus first and last?
      // Anything less than this looks weird with unneccessary '...'s
      if (pageCount.value <= MAX_PAGES_PER_BLOCK + 2) {
        return range(1, Math.min(pageCount.value, MAX_PAGES_PER_BLOCK + 2))
      }

      // block
      const half = Math.floor(MAX_PAGES_PER_BLOCK / 2)
      const start = Math.max(1, Math.min(current.value - half, pageCount.value - MAX_PAGES_PER_BLOCK + 1))
      const end = Math.min(start + MAX_PAGES_PER_BLOCK - 1, pageCount.value)
      const pages = range(start, end)

      // First
      if (start > 1) {
        if (start > 2) {
          pages.unshift(0) // '...'
        }
        pages.unshift(1)
      }

      // Last
      if (end < pageCount.value) {
        if (end < pageCount.value - 1) {
          pages.push(0) // '...'
        }
        pages.push(pageCount.value)
      }

      return pages
    })

    const onLimitChange = () => {
      router.push(routeTo(1))
    }

    const routeTo = (page) => {
      const currentRoute = Object.assign({}, route) // make a copy
      route.query.offset = (parseInt(page) - 1) * parseInt(selectedLimit.value)
      route.query.limit = parseInt(selectedLimit.value)

      if (typeof props.omit === 'object') {
        // Javascript considers arrays as 'object's
        for (let key in currentRoute.query) {
          if (props.omit.includes(key)) {
            delete currentRoute.query[key]
          }
        }
      }

      return currentRoute
    }

    const range = (min, max) => {
      const array = []
      let j = 0
      for (let i = min; i <= max; i++) {
        array[j] = i
        j++
      }
      return array
    }

    if (!limitOptions.value.includes(props.limit)) {
      limitOptions.value.push(props.limit)
      limitOptions.value.sort(function (a, b) {
        return a - b
      })
    }

    return {
      selectedLimit,
      limitOptions,
      pageCount,
      current,
      previous,
      next,
      totalText,
      pages,
      routeTo,
      onLimitChange,
    }
  },
}
</script>

<style lang="scss">
@use '../sass/vars';

.page-item .page-link {
  color: vars.$linkColor;
}

.page-item.active .page-link {
  background-color: vars.$linkColor;
  border-color: vars.$linkColor;
}

.dark {
  .page-item .page-link {
    color: vars.$darkLinkColor;
    background-color: black;
    border-color: vars.$darkSeparatorColor;
  }

  .page-item.disabled .page-link {
    color: vars.$darkSubtextColor;
    border-color: vars.$darkSeparatorColor;
  }

  .page-item.active .page-link {
    color: white;
    background-color: vars.$darkLinkColor;
    border-color: vars.$darkLinkColor;
  }
}
</style>
